package v7.name.panitz.wip;

import v7.name.panitz.wip.Tree.ConDef;
import v7.name.panitz.wip.Tree.FieldSelect;
import v7.name.panitz.wip.Tree.FunCall;
import v7.name.panitz.wip.Tree.FunDef;
import v7.name.panitz.wip.Tree.IfExpr;
import v7.name.panitz.wip.Tree.IntLiteral;
import v7.name.panitz.wip.Tree.OpExpr;
import v7.name.panitz.wip.Tree.Param;
import v7.name.panitz.wip.Tree.Program;
import v7.name.panitz.wip.Tree.Variable;

public class FindTailRecursion implements Visitor<Void>{

	@Override
	public Void visit(IntLiteral il) {
		return null;
	}

	@Override
	public Void visit(OpExpr oe) {
		return null;
	}

	String currentFun = null;
	@Override
	public Void visit(FunDef funDef) {
		currentFun = funDef.name;
		funDef.body.welcome(this);
		return null;
	}

	@Override
	public Void visit(ConDef conDef) {
		return null;
	}

	@Override
	public Void visit(Param param) {
		return null;
	}

	@Override
	public Void visit(Program program) {
		program.funs.stream().forEach(fun-> fun.welcome(this));
		return null;
	}

	@Override
	public Void visit(Variable variable) {
		return null;
	}

	@Override
	public Void visit(FunCall funCall) {
		if (currentFun.equals(funCall.name)) {
			funCall.isTailRecursive = true;
		}
		return null;
	}

	@Override
	public Void visit(FieldSelect fieldSelect) {
		return null;
	}

	@Override
	public Void visit(IfExpr ifExpr) {
		ifExpr.a1.welcome(this);
		ifExpr.a2.welcome(this);
		return null;
	}

}
