package v7.name.panitz.wip;

import java.io.FileReader;

public class WipC {
	public static void main(String args[]) throws Exception {
		WIPParser parser = null;
		if (args.length == 0) {
			System.out.println("type in a program");
			parser = new WIPParser(System.in);
		} else {
			parser = new WIPParser(new FileReader(args[0]));
		}
		var tree = parser.startSymbol();
		System.out.println(tree);
		// System.out.println(tree.eval());
//		var ev = new Eval();
//		var r = tree.welcome(ev);
//		System.out.println(r);
		var tc = new TypeCheck();
		var t = tree.welcome(tc);
		tree.welcome(new FindTailRecursion());
		var jdbc = new GenJBC(tree);
		tree.welcome(jdbc);
		var as = new GenCode();
		tree.welcome(as);
		as.finish();

	}
}
